

#include "BUILTIN.h"
extern OBJ _ASet_18(OBJ,OBJ,OBJ);extern OBJ __ASet_18;
extern OBJ _ASet_26(OBJ,OBJ);extern OBJ __ASet_26;
extern OBJ _ASet_30(OBJ,OBJ,OBJ);extern OBJ __ASet_30;
extern OBJ _ASet_31(OBJ,OBJ,OBJ);extern OBJ __ASet_31;
extern OBJ _ASet_39(OBJ,OBJ,OBJ);extern OBJ __ASet_39;
extern OBJ _ASet_41(OBJ,OBJ,OBJ);extern OBJ __ASet_41;
extern OBJ _ASet_43(OBJ,OBJ,OBJ);extern OBJ __ASet_43;
extern OBJ _ASet_44(OBJ,OBJ,OBJ);extern OBJ __ASet_44;
extern OBJ __AOption_5;
extern OBJ __ASeq_6;
extern OBJ _ASeq_42(OBJ,OBJ);extern OBJ __ASeq_42;
extern OBJ _ASeq_43(OBJ,OBJ,OBJ);extern OBJ __ASeq_43;
extern OBJ _ASeq_52(OBJ,OBJ);extern OBJ __ASeq_52;

#include "Nat.h"
extern OBJ _AMap_8(OBJ,OBJ,OBJ);extern OBJ __AMap_8;
extern OBJ _AMap_13(OBJ,OBJ,OBJ);extern OBJ __AMap_13;
extern OBJ _AMap_14(OBJ,OBJ,OBJ);extern OBJ __AMap_14;
extern OBJ _AMap_15(OBJ,OBJ,OBJ);extern OBJ __AMap_15;
extern OBJ _AMap_16(OBJ,OBJ,OBJ);extern OBJ __AMap_16;
extern OBJ _AMap_17(OBJ,OBJ,OBJ,OBJ);extern OBJ __AMap_17;
extern OBJ _AMap_20(OBJ,OBJ,OBJ);extern OBJ __AMap_20;
extern OBJ _AMap_21(OBJ,OBJ);extern OBJ __AMap_21;
extern OBJ _AMap_23(OBJ,OBJ);extern OBJ __AMap_23;
extern OBJ _AMap_24(OBJ,OBJ,OBJ);extern OBJ __AMap_24;
extern OBJ _AMap_25(OBJ,OBJ,OBJ);extern OBJ __AMap_25;
extern OBJ _AMap_26(OBJ,OBJ,OBJ);extern OBJ __AMap_26;
extern OBJ _AMap_31(OBJ,OBJ,OBJ,OBJ);extern OBJ __AMap_31;
extern OBJ _AMap_33(OBJ,OBJ,OBJ);extern OBJ __AMap_33;
extern OBJ _AMapReduce_5(OBJ,OBJ,OBJ,OBJ);extern OBJ __AMapReduce_5;
extern OBJ _AMapReduce_6(OBJ,OBJ,OBJ,OBJ);extern OBJ __AMapReduce_6;
extern OBJ _AMapFilter_4(OBJ,OBJ,OBJ);extern OBJ __AMapFilter_4;
extern OBJ _AMapMap_5(OBJ,OBJ,OBJ);extern OBJ __AMapMap_5;
extern OBJ _AOptionMap_3(OBJ,OBJ);extern OBJ __AOptionMap_3;
extern OBJ __ATree_7;
extern OBJ _ASeqReduce_3(OBJ,OBJ,OBJ);extern OBJ __ASeqReduce_3;
extern OBJ _ARel_7(OBJ,OBJ);OBJ __ARel_7; /* {} */
extern OBJ _ARel_8(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_8; /* incl */
extern OBJ _ARel_9(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_9; /* incl,1 */
extern OBJ _ARel_10(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_10; /* :-> */
extern OBJ _ARel_11(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_11; /* :->,1 */
extern OBJ _ARel_13(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_13; /* excl */
extern OBJ _ARel_14(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_14; /* extend */
extern OBJ _ARel_15(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_15; /* extend,1 */
extern OBJ _ARel_16(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_16; /* x */
extern OBJ _ARel_17(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_17; /* x,1 */
extern OBJ _ARel_18(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_18; /* x,2 */
extern OBJ _ARel_19(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_19; /* + */
extern OBJ _ARel_20(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_20; /* - */
extern OBJ _ARel_21(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_21; /* * */
extern OBJ _ARel_22(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_22; /* <| */
extern OBJ _ARel_23(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_23; /* |> */
extern OBJ _ARel_24(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_24; /* <~| */
extern OBJ _ARel_25(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_25; /* |~> */
extern TUP2 _ARel_26(OBJ,OBJ,OBJ);OBJ __ARel_26; /* arb */
extern TUP3 _ARel_27(OBJ,OBJ,OBJ);OBJ __ARel_27; /* arb,1 */
extern OBJ _ARel_28(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_28; /* ! */
extern OBJ _ARel_29(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_29; /* !,1 */
extern OBJ _ARel_30(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_30; /* !_c */
extern OBJ _ARel_31(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_31; /* !_c,1 */
extern OBJ _ARel_32(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_32; /* !,2 */
extern OBJ _ARel_33(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_33; /* !? */
extern OBJ _ARel_34(OBJ,OBJ,OBJ);OBJ __ARel_34; /* {}? */
extern OBJ _ARel_35(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_35; /* in */
extern OBJ _ARel_36(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_36; /* def? */
extern OBJ _ARel_37(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_37; /* def_c? */
extern OBJ _ARel_38(OBJ,OBJ,OBJ);OBJ __ARel_38; /* # */
extern OBJ _ARel_39(OBJ,OBJ,OBJ);OBJ __ARel_39; /* dom */
extern OBJ _ARel_40(OBJ,OBJ,OBJ);OBJ __ARel_40; /* codom */
extern OBJ _ARel_41(OBJ,OBJ,OBJ);OBJ __ARel_41; /* bijective? */
extern OBJ _ARel_42(OBJ,OBJ,OBJ);OBJ __ARel_42; /* function? */
extern TUP2 _ARel_43(OBJ,OBJ,OBJ);OBJ __ARel_43; /* min */
extern TUP2 _ARel_44(OBJ,OBJ,OBJ);OBJ __ARel_44; /* max */
extern OBJ _ARel_45(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_45; /* exist? */
extern OBJ _ARel_46(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_46; /* find? */
extern OBJ _ARel_47(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_47; /* forall? */
extern OBJ _ARel_48(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_48; /* exist?,1 */
extern OBJ _ARel_49(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_49; /* find?,1 */
extern OBJ _ARel_50(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_50; /* forall?,1 */
extern OBJ _ARel_51(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_51; /* = */
extern OBJ _ARel_52(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_52; /* < */
extern OBJ _ARel_53(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_53; /* <= */
extern OBJ _ARel_54(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_54; /* disjoint? */
extern OBJ _ARel_55(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_55; /* {<} */
extern OBJ _ARel_56(OBJ,OBJ,OBJ);OBJ __ARel_56; /* abs */
extern OBJ _ARel_57(OBJ,OBJ,OBJ);OBJ __ARel_57; /* abs? */
extern OBJ _ARel_58(OBJ,OBJ,OBJ);OBJ __ARel_58; /* rep */
extern OBJ _ARel_59(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_59; /* cmp */
extern OBJ _ARel_60(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_60; /* @ */
extern OBJ _ARel_61(OBJ,OBJ,OBJ);OBJ __ARel_61; /* clean */
extern OBJ _ARel_62(OBJ,OBJ,OBJ);OBJ __ARel_62; /* x'62 */
extern OBJ _ARel_63(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_63; /* x'63 */
extern OBJ _ARel_64(OBJ,OBJ,OBJ);OBJ __ARel_64; /* x,1'64 */
extern OBJ _ARel_65(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_65; /* x,2'65 */
extern OBJ _ARel_66(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_66; /* +'66 */
extern OBJ _ARel_67(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_67; /* -'67 */
extern OBJ _ARel_68(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_68; /* *'68 */
extern OBJ _ARel_69(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_69; /* *'69 */
extern OBJ _ARel_70(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_70; /* <|'70 */
extern OBJ _ARel_71(OBJ,OBJ);OBJ __ARel_71; /* clean'71 */
extern OBJ _ARel_72(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_72; /* |>'72 */
extern OBJ _ARel_73(OBJ,OBJ,OBJ);OBJ __ARel_73; /* |>'73 */
extern OBJ _ARel_74(OBJ,OBJ,OBJ);OBJ __ARel_74; /* <~|'74 */
extern OBJ _ARel_75(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_75; /* |~>'75 */
extern OBJ _ARel_76(OBJ,OBJ,OBJ);OBJ __ARel_76; /* |~>'76 */
extern OBJ _ARel_77(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_77; /* !,1'77 */
extern OBJ _ARel_78(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_78; /* !_c'78 */
extern OBJ _ARel_79(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_79; /* !_c,1'79 */
extern OBJ _ARel_80(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_80; /* def_c?'80 */
extern OBJ _ARel_81(OBJ,OBJ,OBJ);OBJ __ARel_81; /* function?'81 */
extern OBJ _ARel_82(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_82; /* exist?'82 */
extern OBJ _ARel_83(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_83; /* exist?'83 */
extern OBJ _ARel_84(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_84; /* find?'84 */
extern OBJ _ARel_85(OBJ,OBJ);OBJ __ARel_85; /* find?'85 */
extern OBJ _ARel_86(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_86; /* find?'86 */
extern OBJ _ARel_87(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_87; /* forall?'87 */
extern OBJ _ARel_88(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_88; /* forall?'88 */
extern OBJ _ARel_89(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_89; /* exist?,1'89 */
extern OBJ _ARel_90(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_90; /* exist?,1'90 */
extern OBJ _ARel_91(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_91; /* find?,1'91 */
extern OBJ _ARel_92(OBJ,OBJ);OBJ __ARel_92; /* find?,1'92 */
extern OBJ _ARel_93(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_93; /* find?,1'93 */
extern OBJ _ARel_94(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_94; /* forall?,1'94 */
extern OBJ _ARel_95(OBJ,OBJ,OBJ,OBJ);OBJ __ARel_95; /* forall?,1'95 */
extern OBJ _ARel_96(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_96; /* cmp'96 */
extern OBJ _ARel_97(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_97; /* disjoint?'97 */
extern OBJ _ARel_98(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ARel_98; /* {<}'98 */

extern OBJ _ARel_7(register OBJ x1,register OBJ x2) /* {} */
{OBJ r;
 for(;;){
  continue;
  break;}
 return r;}

extern OBJ _ARel_8(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6) /* incl */
{OBJ r;
 CPCLS(x1,1);
 COPY(x3,1);
 COPY(x6,1);
 {OBJ x7;OBJ x8;
  x7=_AMap_17(x1,__ATree_7,x6,x3);
  x8=_AMap_31(x2,x4,x5,x7);
  r=_AMap_31(x1,x3,x8,x6);}
 return r;}

extern OBJ _ARel_9(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6) /* incl,1 */
{OBJ r;
 CPCLS(x1,1);
 COPY(x3,2);
 COPY(x4,1);
 COPY(x6,1);
 {OBJ x7;OBJ x8;OBJ x9;
  x7=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(x5,2))(x5,x3,x4);
  x8=_AMap_17(x1,__ATree_7,x6,x3);
  x9=_AMap_31(x2,x4,x7,x8);
  r=_AMap_31(x1,x3,x9,x6);}
 return r;}

extern OBJ _ARel_10(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* :-> */
{OBJ r;
 {OBJ x6;
  x6=_AMap_31(x2,x4,x5,__ATree_7);
  r=_AMap_31(x1,x3,x6,__ATree_7);}
 return r;}

extern OBJ _ARel_11(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* :->,1 */
{OBJ r;
 COPY(x3,1);
 COPY(x4,1);
 {OBJ x6;OBJ x7;
  x6=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(x5,2))(x5,x3,x4);
  x7=_AMap_31(x2,x4,x6,__ATree_7);
  r=_AMap_31(x1,x3,x7,__ATree_7);}
 return r;}

extern OBJ _ARel_13(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* excl */
{OBJ r;
 CPCLS(x1,1);
 COPY(x3,1);
 COPY(x5,1);
 {OBJ x6;OBJ x7;
  x6=_AMap_17(x1,__ATree_7,x5,x3);
  x7=_AMap_8(x2,x4,x6);
  if(ISPRM(x7)){
   r=_AMap_8(x1,x3,x5);
  }else{
   r=_AMap_31(x1,x3,x7,x5);}}
 return r;}

extern OBJ _ARel_14(register OBJ x1,register OBJ x2,register OBJ x3,register OBJ x4,register OBJ x5,register OBJ x6) /* extend */
{OBJ r;
 for(;;){
  if(ISPRM(x4)){
   FRCLS(x1,1);
   FRCLS(x2,1);
   if(ISPRM(x5)){
    if(ISPRM(x6)){
     r=x3;
    }else{
     HLT("extend\'Rel: sequences have different length");}
   }else{
    HLT("extend\'Rel: sequences have different length");}
  }else{
   {OBJ x128=FLD1(x4,1);OBJ x129=FLD1(x4,2);
    if(EXPRD(x4,1)){
     DSPRDF(x4);
    }else{
     COPY(x128,1);COPY(x129,1);
     FRPRD(x4,1);}
    if(ISPRM(x5)){
     HLT("extend\'Rel: sequences have different length");
    }else{
     {OBJ x130=FLD1(x5,1);OBJ x131=FLD1(x5,2);
      if(EXPRD(x5,1)){
       DSPRDF(x5);
      }else{
       COPY(x130,1);COPY(x131,1);
       FRPRD(x5,1);}
      if(ISPRM(x6)){
       HLT("extend\'Rel: sequences have different length");
      }else{
       {OBJ x132=FLD1(x6,1);OBJ x133=FLD1(x6,2);
	if(EXPRD(x6,1)){
	 DSPRDF(x6);
	}else{
	 COPY(x132,1);COPY(x133,1);
	 FRPRD(x6,1);}
	CPCLS(x1,1);
	CPCLS(x2,1);
	{OBJ x137;
	 x137=_ARel_8(x1,x2,x128,x130,x132,x3);
	 x3=x137;x4=x129;x5=x131;x6=x133;continue;}}}}}}}
  break;}
 return r;}

extern OBJ _ARel_15(register OBJ x1,register OBJ x2,register OBJ x3,register OBJ x4,register OBJ x5,register OBJ x6) /* extend,1 */
{OBJ r;
 for(;;){
  if(ISPRM(x4)){
   FRCLS(x1,1);
   FRCLS(x2,1);
   FRCLS(x6,1);
   if(ISPRM(x5)){
    r=x3;
   }else{
    HLT("extend\'Rel: sequences have different length");}
  }else{
   {OBJ x72=FLD1(x4,1);OBJ x73=FLD1(x4,2);
    if(EXPRD(x4,1)){
     DSPRDF(x4);
    }else{
     COPY(x72,1);COPY(x73,1);
     FRPRD(x4,1);}
    if(ISPRM(x5)){
     HLT("extend\'Rel: sequences have different length");
    }else{
     {OBJ x74=FLD1(x5,1);OBJ x75=FLD1(x5,2);
      if(EXPRD(x5,1)){
       COPY(x74,1);
       DSPRDF(x5);
      }else{
       COPY(x74,2);COPY(x75,1);
       FRPRD(x5,1);}
      CPCLS(x1,1);
      CPCLS(x2,1);
      CPCLS(x6,1);
      COPY(x72,1);
      {OBJ x78;OBJ x79;
       x78=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(x6,2))(x6,x72,x74);
       x79=_ARel_8(x1,x2,x72,x74,x78,x3);
       x3=x79;x4=x73;x5=x75;continue;}}}}}
  break;}
 return r;}

extern OBJ _ARel_16(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* x */
{OBJ r;
 CPCLS(__ARel_63,1);
 {OBJ x6;
  x6=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ))METHOD(__ARel_63,4))(__ARel_63,x1,x2,x4,x5);
  r=_ASeqReduce_3(x6,__ATree_7,x3);}
 return r;}

extern OBJ _ARel_17(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* x,1 */
{OBJ r;
 CPCLS(__ARel_64,1);
 COPY(x3,1);
 {OBJ x6;OBJ x7;
  x6=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_64,2))(__ARel_64,x3,x5);
  x7=_AMap_13(x2,x4,x6);
  r=_AMap_31(x1,x3,x7,__ATree_7);}
 return r;}

extern OBJ _ARel_18(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* x,2 */
{OBJ r;
 CPCLS(__ARel_65,1);
 {OBJ x6;
  x6=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ))METHOD(__ARel_65,4))(__ARel_65,x1,x2,x4,x5);
  r=_ASeqReduce_3(x6,__ATree_7,x3);}
 return r;}

extern OBJ _ARel_19(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* + */
{OBJ r;
 CPCLS(__ARel_66,1);
 CPCLS(x1,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_66,2))(__ARel_66,x1,x2);
  r=_AMapReduce_6(x1,x5,x3,x4);}
 return r;}

extern OBJ _ARel_20(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* - */
{OBJ r;
 CPCLS(__ARel_67,1);
 CPCLS(x1,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_67,2))(__ARel_67,x1,x2);
  r=_AMapReduce_6(x1,x5,x3,x4);}
 return r;}

extern OBJ _ARel_21(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* * */
{OBJ r;
 CPCLS(__ARel_69,1);
 CPCLS(x1,3);
 COPY(x3,1);
 COPY(x4,1);
 {OBJ x5;OBJ x6;OBJ x7;OBJ x8;
  x5=_AMap_21(x1,x3);
  x6=_AMap_21(x1,x4);
  x7=_ASet_43(x1,x5,x6);
  x8=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ))METHOD(__ARel_69,4))(__ARel_69,x1,x2,x3,x4);
  r=_ASeqReduce_3(x8,__ATree_7,x7);}
 return r;}

extern OBJ _ARel_22(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* <| */
{OBJ r;
 CPCLS(__ARel_70,1);
 FRCLS(x2,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_70,2))(__ARel_70,x1,x4);
  r=_ASeqReduce_3(x5,__ATree_7,x3);}
 return r;}

extern OBJ _ARel_23(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* |> */
{OBJ r;
 CPCLS(__ARel_71,1);
 CPCLS(__ARel_73,1);
 CPCLS(x1,1);
 {OBJ x5;OBJ x6;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_73,2))(__ARel_73,x2,x4);
  x6=_AMapMap_5(x1,x5,x3);
  r=_AMapFilter_4(x1,__ARel_71,x6);}
 return r;}

extern OBJ _ARel_24(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* <~| */
{OBJ r;
 CPCLS(__ARel_74,1);
 FRCLS(x2,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ))METHOD(__ARel_74,1))(__ARel_74,x1);
  r=_ASeqReduce_3(x5,x4,x3);}
 return r;}

extern OBJ _ARel_25(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* |~> */
{OBJ r;
 CPCLS(__ARel_71,1);
 CPCLS(__ARel_76,1);
 CPCLS(x1,1);
 {OBJ x5;OBJ x6;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_76,2))(__ARel_76,x2,x4);
  x6=_AMapMap_5(x1,x5,x3);
  r=_AMapFilter_4(x1,__ARel_71,x6);}
 return r;}

extern TUP2 _ARel_26(OBJ x1,OBJ x2,OBJ x3) /* arb */
{TUP2 r;
 r=_ARel_43(x1,x2,x3);
 return r;}
extern OBJ _ARel_26_c(OBJ x1,OBJ x2,OBJ x3) /* arb */
{OBJ r;
 {TUP2 t=_ARel_26(x1,x2,x3);
  PRD1(2,r);
  FLD1(r,1)=t.c1;
  FLD1(r,2)=t.c2;}
 return r;}

extern TUP3 _ARel_27(OBJ x1,OBJ x2,OBJ x3) /* arb,1 */
{TUP3 r;
 CPCLS(x1,1);
 CPCLS(x2,1);
 COPY(x3,1);
 {TUP2 t=_ARel_43(x1,x2,x3);
  r.c1=t.c1;
  r.c2=t.c2;}
 COPY(r.c1,1);
 COPY(r.c2,1);
 r.c3=_ARel_32(x1,x2,x3,r.c1,r.c2);
 return r;}
extern OBJ _ARel_27_c(OBJ x1,OBJ x2,OBJ x3) /* arb,1 */
{OBJ r;
 {TUP3 t=_ARel_27(x1,x2,x3);
  PRD1(3,r);
  FLD1(r,1)=t.c1;
  FLD1(r,2)=t.c2;
  FLD1(r,3)=t.c3;}
 return r;}

extern OBJ _ARel_28(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* ! */
{OBJ r;
 {OBJ x5;
  x5=_AMap_17(x1,__ATree_7,x3,x4);
  r=_AMap_21(x2,x5);}
 return r;}

extern OBJ _ARel_29(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* !,1 */
{OBJ r;
 CPCLS(__ARel_77,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ))METHOD(__ARel_77,3))(__ARel_77,x1,x2,x3);
  r=_ASeqReduce_3(x5,__ASeq_6,x4);}
 return r;}

extern OBJ _ARel_30(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* !_c */
{OBJ r;
 CPCLS(__ARel_78,1);
 CPCLS(x1,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ))METHOD(__ARel_78,3))(__ARel_78,x1,x2,x4);
  r=_AMapReduce_6(x1,x5,__ASeq_6,x3);}
 return r;}

extern OBJ _ARel_31(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* !_c,1 */
{OBJ r;
 CPCLS(__ARel_79,1);
 CPCLS(x1,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ))METHOD(__ARel_79,3))(__ARel_79,x1,x2,x4);
  r=_AMapReduce_6(x1,x5,__ASeq_6,x3);}
 return r;}

extern OBJ _ARel_32(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* !,2 */
{OBJ r;
 {OBJ x6;
  x6=_AMap_33(x1,x3,x4);
  if(ISPRM(x6)){
   HLT("!\'Rel: pair not in relation");
  }else{
   {OBJ x16=FLD1(x6,1);
    if(EXPRD(x6,1)){
     DSPRDF(x6);
    }else{
     COPY(x16,1);
     FRPRD(x6,1);}
    {OBJ x17;
     x17=_AMap_33(x2,x16,x5);
     if(ISPRM(x17)){
      HLT("!\'Rel: pair not in relation");
     }else{
      {OBJ x18=FLD1(x17,1);
       if(EXPRD(x17,1)){
	r=x18;
	DSPRDF(x17);
       }else{
	COPY(x18,1);
	r=x18;
	FRPRD(x17,1);}}}}}}}
 return r;}

extern OBJ _ARel_33(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* !? */
{OBJ r;
 {OBJ x6;
  x6=_AMap_33(x1,x3,x4);
  if(ISPRM(x6)){
   FRCLS(x2,1);
   FREE(x5,1);
   r=__AOption_5;
  }else{
   {OBJ x11=FLD1(x6,1);
    if(EXPRD(x6,1)){
     DSPRDF(x6);
    }else{
     COPY(x11,1);
     FRPRD(x6,1);}
    r=_AMap_33(x2,x11,x5);}}}
 return r;}

extern OBJ _ARel_34(OBJ x1,OBJ x2,OBJ x3) /* {}? */
{OBJ r;
 {OBJ x4;
  x4=_ARel_38(x1,x2,x3);
  ANat_6(x4,r);}
 return r;}

extern OBJ _ARel_35(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* in */
{OBJ r;
 {OBJ x6;
  x6=_AMap_33(x1,x5,x3);
  if(ISPRM(x6)){
   FRCLS(x2,1);
   FREE(x4,1);
   r=__ABUILTIN_3;
  }else{
   {OBJ x13=FLD1(x6,1);
    if(EXPRD(x6,1)){
     DSPRDF(x6);
    }else{
     COPY(x13,1);
     FRPRD(x6,1);}
    {OBJ x14;
     x14=_AMap_33(x2,x13,x4);
     if(ISPRM(x14)){
      r=__ABUILTIN_3;
     }else{
      if(EXPRD(x14,1)){
       FREE(FLD1(x14,1),1);DSPRDF(x14);
      }else{
       DCPRD(x14,1);}
      r=__ABUILTIN_5;}}}}}
 return r;}

extern OBJ _ARel_36(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* def? */
{OBJ r;
 FRCLS(x2,1);
 {OBJ x5;
  x5=_AMap_33(x1,x3,x4);
  if(ISPRM(x5)){
   r=__ABUILTIN_3;
  }else{
   {OBJ x17=FLD1(x5,1);
    if(EXPRD(x5,1)){
     DSPRDF(x5);
    }else{
     COPY(x17,1);
     FRPRD(x5,1);}
    if(ISPRM(x17)){
     r=__ABUILTIN_3;
    }else{
     if(EXPRD(x17,1)){
      DSPRD(x17);
     }else{
      DCPRD(x17,1);}
     r=__ABUILTIN_5;}}}}
 return r;}

extern OBJ _ARel_37(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* def_c? */
{OBJ r;
 CPCLS(__ARel_80,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_80,2))(__ARel_80,x2,x4);
  r=_AMap_24(x1,x5,x3);}
 return r;}

extern OBJ _ARel_38(OBJ x1,OBJ x2,OBJ x3) /* # */
{OBJ r;
 CPCLS(__ANat_61,1);
 CPCLS(__AMap_23,1);
 CPCLS(x1,1);
 {OBJ x4;OBJ x5;
  x4=(*(OBJ(*)(OBJ,OBJ))METHOD(__AMap_23,1))(__AMap_23,x2);
  x5=_AMapMap_5(x1,x4,x3);
  r=_AMapReduce_5(x1,__ANat_61,__ANat_5,x5);}
 return r;}

extern OBJ _ARel_39(OBJ x1,OBJ x2,OBJ x3) /* dom */
{OBJ r;
 CPCLS(__ARel_71,1);
 CPCLS(x1,1);
 FRCLS(x2,1);
 {OBJ x4;
  x4=_AMapFilter_4(x1,__ARel_71,x3);
  r=_AMap_21(x1,x4);}
 return r;}

extern OBJ _ARel_40(OBJ x1,OBJ x2,OBJ x3) /* codom */
{OBJ r;
 CPCLS(__ASet_18,1);
 CPCLS(__AMap_21,1);
 CPCLS(x1,1);
 CPCLS(x2,1);
 {OBJ x4;OBJ x5;OBJ x6;
  x4=(*(OBJ(*)(OBJ,OBJ))METHOD(__ASet_18,1))(__ASet_18,x2);
  x5=(*(OBJ(*)(OBJ,OBJ))METHOD(__AMap_21,1))(__AMap_21,x2);
  x6=_AMapMap_5(x1,x5,x3);
  r=_AMapReduce_5(x1,x4,__ASeq_6,x6);}
 return r;}

extern OBJ _ARel_41(OBJ x1,OBJ x2,OBJ x3) /* bijective? */
{OBJ r;
 CPCLS(x1,1);
 CPCLS(x2,1);
 COPY(x3,1);
 {OBJ x4;
  x4=_ARel_42(x1,x2,x3);
  if(ISTGPRM(x4,1)){
   CPCLS(x1,2);
   COPY(x3,1);
   CPCLS(__ARel_71,1);
   {OBJ x5;OBJ x6;OBJ x7;OBJ x8;OBJ x9;
    x5=_AMapFilter_4(x1,__ARel_71,x3);
    x6=_ARel_40(x1,x2,x3);
    x7=_AMap_21(x1,x5);
    x8=_ASeq_52(x6,__ANat_5);
    x9=_ASeq_52(x7,__ANat_5);
    ANat_76(x9,x8,r);}
  }else{
   FRCLS(x1,1);
   FRCLS(x2,1);
   FREE(x3,1);
   r=__ABUILTIN_3;}}
 return r;}

extern OBJ _ARel_42(OBJ x1,OBJ x2,OBJ x3) /* function? */
{OBJ r;
 CPCLS(__ARel_71,1);
 CPCLS(__ARel_81,1);
 CPCLS(x1,1);
 {OBJ x4;OBJ x5;
  x4=_AMapFilter_4(x1,__ARel_71,x3);
  x5=(*(OBJ(*)(OBJ,OBJ))METHOD(__ARel_81,1))(__ARel_81,x2);
  r=_AMap_26(x1,x5,x4);}
 return r;}

extern TUP2 _ARel_43(OBJ x1,OBJ x2,OBJ x3) /* min */
{TUP2 r;
 CPCLS(__ARel_71,1);
 CPCLS(x1,2);
 {OBJ x4;OBJ x5;OBJ x8;OBJ x9;OBJ x10;OBJ x13;
  x4=_AMapFilter_4(x1,__ARel_71,x3);
  COPY(x4,1);
  x5=_AMap_21(x1,x4);
  if(ISPRM(x5)){
   HLT("min\'Set: applied to empty set");
  }else{
   {OBJ x6=FLD1(x5,1);
    if(EXPRD(x5,1)){
     x8=x6;
     FREE(FLD1(x5,2),1);DSPRDF(x5);
    }else{
     COPY(x6,1);
     x8=x6;
     FRPRD(x5,1);}}}
  COPY(x8,1);
  x9=_AMap_16(x1,x4,x8);
  x10=_AMap_21(x2,x9);
  if(ISPRM(x10)){
   HLT("min\'Set: applied to empty set");
  }else{
   {OBJ x11=FLD1(x10,1);
    if(EXPRD(x10,1)){
     r.c1=x8;r.c2=x11;
     FREE(FLD1(x10,2),1);DSPRDF(x10);
    }else{
     COPY(x11,1);
     r.c1=x8;r.c2=x11;
     FRPRD(x10,1);}}}}
 return r;}
extern OBJ _ARel_43_c(OBJ x1,OBJ x2,OBJ x3) /* min */
{OBJ r;
 {TUP2 t=_ARel_43(x1,x2,x3);
  PRD1(2,r);
  FLD1(r,1)=t.c1;
  FLD1(r,2)=t.c2;}
 return r;}

extern TUP2 _ARel_44(OBJ x1,OBJ x2,OBJ x3) /* max */
{TUP2 r;
 CPCLS(__ARel_71,1);
 CPCLS(x1,3);
 CPCLS(x2,1);
 {OBJ x4;OBJ x5;OBJ x7;OBJ x8;
  x4=_AMapFilter_4(x1,__ARel_71,x3);
  COPY(x4,1);
  x5=_AMap_21(x1,x4);
  r.c1=_ASet_26(x1,x5);
  COPY(r.c1,1);
  x7=_AMap_16(x1,x4,r.c1);
  x8=_AMap_21(x2,x7);
  r.c2=_ASet_26(x2,x8);}
 return r;}
extern OBJ _ARel_44_c(OBJ x1,OBJ x2,OBJ x3) /* max */
{OBJ r;
 {TUP2 t=_ARel_44(x1,x2,x3);
  PRD1(2,r);
  FLD1(r,1)=t.c1;
  FLD1(r,2)=t.c2;}
 return r;}

extern OBJ _ARel_45(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* exist? */
{OBJ r;
 CPCLS(__ARel_83,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_83,2))(__ARel_83,x2,x3);
  r=_AMap_24(x1,x5,x4);}
 return r;}

extern OBJ _ARel_46(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* find? */
{OBJ r;
 CPCLS(__ARel_86,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_86,2))(__ARel_86,x2,x3);
  r=_AMapReduce_6(x1,x5,__AOption_5,x4);}
 return r;}

extern OBJ _ARel_47(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* forall? */
{OBJ r;
 CPCLS(__ARel_88,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_88,2))(__ARel_88,x2,x3);
  r=_AMap_26(x1,x5,x4);}
 return r;}

extern OBJ _ARel_48(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* exist?,1 */
{OBJ r;
 CPCLS(__ARel_90,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_90,2))(__ARel_90,x2,x3);
  r=_AMap_24(x1,x5,x4);}
 return r;}

extern OBJ _ARel_49(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* find?,1 */
{OBJ r;
 CPCLS(__ARel_93,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_93,2))(__ARel_93,x2,x3);
  r=_AMapReduce_6(x1,x5,__AOption_5,x4);}
 return r;}

extern OBJ _ARel_50(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* forall?,1 */
{OBJ r;
 CPCLS(__ARel_95,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_95,2))(__ARel_95,x2,x3);
  r=_AMap_26(x1,x5,x4);}
 return r;}

extern OBJ _ARel_51(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* = */
{OBJ r;
 CPCLS(__ASet_30,2);
 CPCLS(x1,1);
 CPCLS(x2,1);
 {OBJ x5;OBJ x6;
  x5=(*(OBJ(*)(OBJ,OBJ))METHOD(__ASet_30,1))(__ASet_30,x1);
  x6=(*(OBJ(*)(OBJ,OBJ))METHOD(__ASet_30,1))(__ASet_30,x2);
  r=_ARel_59(x1,x2,x5,x6,x3,x4);}
 return r;}

extern OBJ _ARel_52(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* < */
{OBJ r;
 CPCLS(x1,1);
 CPCLS(x2,1);
 COPY(x3,1);
 COPY(x4,1);
 {OBJ x5;
  x5=_ARel_53(x1,x2,x3,x4);
  if(ISTGPRM(x5,1)){
   {OBJ x6;
    x6=_ARel_51(x1,x2,x3,x4);
    if(ISTGPRM(x6,1)){
     r=__ABUILTIN_3;
    }else{
     r=__ABUILTIN_5;}}
  }else{
   FRCLS(x1,1);
   FRCLS(x2,1);
   FREE(x3,1);
   FREE(x4,1);
   r=__ABUILTIN_3;}}
 return r;}

extern OBJ _ARel_53(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* <= */
{OBJ r;
 CPCLS(__ASet_31,2);
 CPCLS(x1,1);
 CPCLS(x2,1);
 {OBJ x5;OBJ x6;
  x5=(*(OBJ(*)(OBJ,OBJ))METHOD(__ASet_31,1))(__ASet_31,x1);
  x6=(*(OBJ(*)(OBJ,OBJ))METHOD(__ASet_31,1))(__ASet_31,x2);
  r=_ARel_59(x1,x2,x5,x6,x3,x4);}
 return r;}

extern OBJ _ARel_54(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* disjoint? */
{OBJ r;
 CPCLS(__ARel_97,1);
 CPCLS(x1,3);
 COPY(x3,1);
 COPY(x4,1);
 {OBJ x5;OBJ x6;OBJ x7;OBJ x8;
  x5=_AMap_21(x1,x3);
  x6=_AMap_21(x1,x4);
  x7=_ASet_43(x1,x5,x6);
  x8=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ))METHOD(__ARel_97,4))(__ARel_97,x1,x2,x3,x4);
  r=_ASeq_42(x8,x7);}
 return r;}

extern OBJ _ARel_55(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* {<} */
{OBJ r;
 CPCLS(__ARel_98,1);
 CPCLS(x1,3);
 COPY(x3,1);
 COPY(x4,1);
 {OBJ x5;OBJ x6;OBJ x7;OBJ x8;
  x5=_AMap_21(x1,x3);
  x6=_AMap_21(x1,x4);
  x7=_ASet_41(x1,x5,x6);
  x8=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ))METHOD(__ARel_98,4))(__ARel_98,x1,x2,x3,x4);
  r=_ASeqReduce_3(x8,__ABUILTIN_3,x7);}
 return r;}

extern OBJ _ARel_56(OBJ x1,OBJ x2,OBJ x3) /* abs */
{OBJ r;
 FRCLS(x1,1);
 FRCLS(x2,1);
 r=x3;
 return r;}

extern OBJ _ARel_57(OBJ x1,OBJ x2,OBJ x3) /* abs? */
{OBJ r;
 FRCLS(x1,1);
 FRCLS(x2,1);
 FREE(x3,1);
 r=__ABUILTIN_5;
 return r;}

extern OBJ _ARel_58(OBJ x1,OBJ x2,OBJ x3) /* rep */
{OBJ r;
 FRCLS(x1,1);
 FRCLS(x2,1);
 r=x3;
 return r;}

extern OBJ _ARel_59(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6) /* cmp */
{OBJ r;
 CPCLS(x1,2);
 COPY(x5,1);
 COPY(x6,1);
 {OBJ x7;OBJ x8;OBJ x9;
  x7=_AMap_21(x1,x5);
  COPY(x7,1);
  x8=_AMap_21(x1,x6);
  x9=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(x3,2))(x3,x7,x8);
  if(ISTGPRM(x9,1)){
   CPCLS(__ARel_96,1);
   {OBJ x10;
    x10=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))METHOD(__ARel_96,5))(__ARel_96,x1,x2,x4,x5,x6);
    r=_ASeq_42(x10,x7);}
  }else{
   FRCLS(x1,1);
   FRCLS(x2,1);
   FRCLS(x4,1);
   FREE(x5,1);
   FREE(x6,1);
   FREE(x7,1);
   r=__ABUILTIN_3;}}
 return r;}

extern OBJ _ARel_60(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* @ */
{OBJ r;
 FRCLS(x2,1);
 r=_AMap_17(x1,__ATree_7,x3,x4);
 return r;}

extern OBJ _ARel_61(OBJ x1,OBJ x2,OBJ x3) /* clean */
{OBJ r;
 CPCLS(__ARel_71,1);
 FRCLS(x2,1);
 r=_AMapFilter_4(x1,__ARel_71,x3);
 return r;}

extern OBJ _ARel_62(OBJ x1,OBJ x2,OBJ x3) /* x'62 */
{OBJ r;
 r=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(x1,2))(x1,x2,x3);
 return r;}

extern OBJ _ARel_63(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6) /* x'63 */
{OBJ r;
 CPCLS(__ARel_62,1);
 COPY(x5,1);
 {OBJ x7;OBJ x8;
  x7=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_62,2))(__ARel_62,x4,x5);
  x8=_AMap_13(x2,x3,x7);
  r=_AMap_31(x1,x5,x8,x6);}
 return r;}

extern OBJ _ARel_64(OBJ x1,OBJ x2,OBJ x3) /* x,1'64 */
{OBJ r;
 r=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(x2,2))(x2,x1,x3);
 return r;}

extern OBJ _ARel_65(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6) /* x,2'65 */
{OBJ r;
 COPY(x3,1);
 COPY(x5,1);
 {OBJ x7;OBJ x8;
  x7=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(x4,2))(x4,x5,x3);
  x8=_AMap_31(x2,x3,x7,__ATree_7);
  r=_AMap_31(x1,x5,x8,x6);}
 return r;}

extern OBJ _ARel_66(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* +'66 */
{OBJ r;
 CPCLS(x1,1);
 COPY(x3,1);
 COPY(x5,1);
 {OBJ x6;OBJ x7;
  x6=_AMap_17(x1,__ATree_7,x5,x3);
  x7=_AMap_14(x2,x6,x4);
  r=_AMap_31(x1,x3,x7,x5);}
 return r;}

extern OBJ _ARel_67(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* -'67 */
{OBJ r;
 CPCLS(x1,1);
 CPCLS(x2,1);
 COPY(x3,1);
 COPY(x5,1);
 {OBJ x6;OBJ x7;OBJ x8;
  x6=_AMap_17(x1,__ATree_7,x5,x3);
  x7=_AMap_21(x2,x4);
  x8=_AMap_15(x2,x6,x7);
  r=_AMap_31(x1,x3,x8,x5);}
 return r;}

extern OBJ _ARel_68(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6) /* *'68 */
{OBJ r;
 FREE(x6,1);
 {OBJ x7;
  x7=_AMap_17(x1,__ATree_7,x3,x4);
  r=_AMap_20(x2,x5,x7);}
 return r;}

extern OBJ _ARel_69(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6) /* *'69 */
{OBJ r;
 CPCLS(__ARel_68,1);
 CPCLS(x1,2);
 CPCLS(x2,1);
 COPY(x5,2);
 {OBJ x7;OBJ x8;OBJ x9;
  x7=_AMap_17(x1,__ATree_7,x3,x5);
  x8=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ))METHOD(__ARel_68,4))(__ARel_68,x1,x2,x4,x5);
  x9=_AMapFilter_4(x2,x8,x7);
  r=_AMap_31(x1,x5,x9,x6);}
 return r;}

extern OBJ _ARel_70(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* <|'70 */
{OBJ r;
 CPCLS(x1,1);
 COPY(x2,1);
 COPY(x3,1);
 {OBJ x5;
  x5=_AMap_20(x1,x3,x2);
  if(ISTGPRM(x5,1)){
   CPCLS(x1,1);
   COPY(x3,1);
   {OBJ x6;
    x6=_AMap_16(x1,x2,x3);
    r=_AMap_31(x1,x3,x6,x4);}
  }else{
   FRCLS(x1,1);
   FREE(x2,1);
   FREE(x3,1);
   r=x4;}}
 return r;}

extern OBJ _ARel_71(OBJ x1,OBJ x2) /* clean'71 */
{OBJ r;
 FREE(x1,1);
 if(ISPRM(x2)){
  r=__ABUILTIN_3;
 }else{
  if(EXPRD(x2,1)){
   DSPRD(x2);
  }else{
   DCPRD(x2,1);}
  r=__ABUILTIN_5;}
 return r;}

extern OBJ _ARel_72(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* |>'72 */
{OBJ r;
 FREE(x4,1);
 r=_ASet_44(x1,x3,x2);
 return r;}

extern OBJ _ARel_73(OBJ x1,OBJ x2,OBJ x3) /* |>'73 */
{OBJ r;
 CPCLS(__ARel_72,1);
 CPCLS(x1,1);
 {OBJ x4;
  x4=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_72,2))(__ARel_72,x1,x2);
  r=_AMapFilter_4(x1,x4,x3);}
 return r;}

extern OBJ _ARel_74(OBJ x1,OBJ x2,OBJ x3) /* <~|'74 */
{OBJ r;
 r=_AMap_8(x1,x2,x3);
 return r;}

extern OBJ _ARel_75(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* |~>'75 */
{OBJ r;
 FREE(x4,1);
 {OBJ x5;
  x5=_ASet_44(x1,x3,x2);
  if(ISTGPRM(x5,1)){
   r=__ABUILTIN_3;
  }else{
   r=__ABUILTIN_5;}}
 return r;}

extern OBJ _ARel_76(OBJ x1,OBJ x2,OBJ x3) /* |~>'76 */
{OBJ r;
 CPCLS(__ARel_75,1);
 CPCLS(x1,1);
 {OBJ x4;
  x4=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_75,2))(__ARel_75,x1,x2);
  r=_AMapFilter_4(x1,x4,x3);}
 return r;}

extern OBJ _ARel_77(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* !,1'77 */
{OBJ r;
 CPCLS(x2,1);
 {OBJ x6;OBJ x7;
  x6=_AMap_17(x1,__ATree_7,x3,x4);
  x7=_AMap_21(x2,x6);
  r=_ASet_41(x2,x7,x5);}
 return r;}

extern OBJ _ARel_78(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6) /* !_c'78 */
{OBJ r;
 {OBJ x7;
  x7=_AMap_20(x2,x3,x5);
  if(ISTGPRM(x7,1)){
   r=_ASet_39(x1,x4,x6);
  }else{
   FRCLS(x1,1);
   FREE(x4,1);
   r=x6;}}
 return r;}

extern OBJ _ARel_79(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6) /* !_c,1'79 */
{OBJ r;
 CPCLS(x2,1);
 {OBJ x7;OBJ x8;
  x7=_AMap_21(x2,x5);
  x8=_ASet_43(x2,x3,x7);
  if(ISPRM(x8)){
   FRCLS(x1,1);
   FREE(x4,1);
   r=x6;
  }else{
   if(EXPRD(x8,1)){
    DSPRD(x8);
   }else{
    DCPRD(x8,1);}
   r=_ASet_39(x1,x4,x6);}}
 return r;}

extern OBJ _ARel_80(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* def_c?'80 */
{OBJ r;
 FREE(x3,1);
 r=_AMap_20(x1,x2,x4);
 return r;}

extern OBJ _ARel_81(OBJ x1,OBJ x2,OBJ x3) /* function?'81 */
{OBJ r;
 FREE(x2,1);
 {OBJ x4;OBJ x5;
  x4=_AMap_21(x1,x3);
  x5=_ASeq_52(x4,__ANat_5);
  ANat_76(x5,__ANat_8,r);}
 return r;}

extern OBJ _ARel_82(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* exist?'82 */
{OBJ r;
 FREE(x4,1);
 r=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(x1,2))(x1,x2,x3);
 return r;}

extern OBJ _ARel_83(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* exist?'83 */
{OBJ r;
 CPCLS(__ARel_82,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_82,2))(__ARel_82,x2,x3);
  r=_AMap_24(x1,x5,x4);}
 return r;}

extern OBJ _ARel_84(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* find?'84 */
{OBJ r;
 FREE(x4,1);
 r=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(x1,2))(x1,x2,x3);
 return r;}

extern OBJ _ARel_85(OBJ x1,OBJ x2) /* find?'85 */
{OBJ r;
 {OBJ x3=FLD1(x2,1);
  if(EXPRD(x2,1)){
   {OBJ x5;
    x5=x3;
    RSOME(x2,r);FLD1(r,1)=x1;FREE(FLD1(r,2),1);FLD1(r,2)=x5;}
  }else{
   COPY(x3,1);
   {OBJ x5;
    x5=x3;
    FRPRD(x2,1);PRD1(2,r);FLD1(r,1)=x1;FLD1(r,2)=x5;}}}
 return r;}

extern OBJ _ARel_86(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* find?'86 */
{OBJ r;
 if(ISPRM(x5)){
  COPY(x3,1);
  CPCLS(__ARel_84,1);
  CPCLS(__ARel_85,1);
  {OBJ x12;OBJ x13;OBJ x14;
   x12=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_84,2))(__ARel_84,x2,x3);
   x13=_AMap_25(x1,x12,x4);
   x14=(*(OBJ(*)(OBJ,OBJ))METHOD(__ARel_85,1))(__ARel_85,x3);
   r=_AOptionMap_3(x14,x13);}
 }else{
  FRCLS(x1,1);
  FRCLS(x2,1);
  FREE(x3,1);
  FREE(x4,1);
  r=x5;}
 return r;}

extern OBJ _ARel_87(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* forall?'87 */
{OBJ r;
 FREE(x4,1);
 r=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(x1,2))(x1,x2,x3);
 return r;}

extern OBJ _ARel_88(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* forall?'88 */
{OBJ r;
 CPCLS(__ARel_87,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_87,2))(__ARel_87,x2,x3);
  r=_AMap_26(x1,x5,x4);}
 return r;}

extern OBJ _ARel_89(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* exist?,1'89 */
{OBJ r;
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ))METHOD(x1,3))(x1,x2,x3,x4);
 return r;}

extern OBJ _ARel_90(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* exist?,1'90 */
{OBJ r;
 CPCLS(__ARel_89,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_89,2))(__ARel_89,x2,x3);
  r=_AMap_24(x1,x5,x4);}
 return r;}

extern OBJ _ARel_91(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* find?,1'91 */
{OBJ r;
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ))METHOD(x1,3))(x1,x2,x3,x4);
 return r;}

extern OBJ _ARel_92(OBJ x1,OBJ x2) /* find?,1'92 */
{OBJ r;
 {OBJ x9=FLD1(x2,1);OBJ x10=FLD1(x2,2);
  if(EXPRD(x2,1)){
   DSPRDF(x2);
  }else{
   COPY(x9,1);COPY(x10,1);
   FRPRD(x2,1);}
  PRD1(3,r);FLD1(r,1)=x1;FLD1(r,2)=x9;FLD1(r,3)=x10;}
 return r;}

extern OBJ _ARel_93(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* find?,1'93 */
{OBJ r;
 if(ISPRM(x5)){
  COPY(x3,1);
  CPCLS(__ARel_91,1);
  CPCLS(__ARel_92,1);
  {OBJ x12;OBJ x13;OBJ x14;
   x12=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_91,2))(__ARel_91,x2,x3);
   x13=_AMap_25(x1,x12,x4);
   x14=(*(OBJ(*)(OBJ,OBJ))METHOD(__ARel_92,1))(__ARel_92,x3);
   r=_AOptionMap_3(x14,x13);}
 }else{
  FRCLS(x1,1);
  FRCLS(x2,1);
  FREE(x3,1);
  FREE(x4,1);
  r=x5;}
 return r;}

extern OBJ _ARel_94(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* forall?,1'94 */
{OBJ r;
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ))METHOD(x1,3))(x1,x2,x3,x4);
 return r;}

extern OBJ _ARel_95(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* forall?,1'95 */
{OBJ r;
 CPCLS(__ARel_94,1);
 {OBJ x5;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ARel_94,2))(__ARel_94,x2,x3);
  r=_AMap_26(x1,x5,x4);}
 return r;}

extern OBJ _ARel_96(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6) /* cmp'96 */
{OBJ r;
 CPCLS(x1,1);
 CPCLS(x2,1);
 COPY(x6,1);
 {OBJ x7;OBJ x8;OBJ x9;OBJ x10;
  x7=_AMap_16(x1,x4,x6);
  x8=_AMap_16(x1,x5,x6);
  x9=_AMap_21(x2,x7);
  x10=_AMap_21(x2,x8);
  r=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(x3,2))(x3,x9,x10);}
 return r;}

extern OBJ _ARel_97(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* disjoint?'97 */
{OBJ r;
 CPCLS(x1,1);
 CPCLS(x2,2);
 COPY(x5,1);
 {OBJ x6;OBJ x7;OBJ x8;OBJ x9;OBJ x10;
  x6=_AMap_16(x1,x3,x5);
  x7=_AMap_16(x1,x4,x5);
  x8=_AMap_21(x2,x6);
  x9=_AMap_21(x2,x7);
  x10=_ASet_43(x2,x8,x9);
  if(ISPRM(x10)){
   r=__ABUILTIN_5;
  }else{
   if(EXPRD(x10,1)){
    DSPRD(x10);
   }else{
    DCPRD(x10,1);}
   r=__ABUILTIN_3;}}
 return r;}

extern OBJ _ARel_98(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6) /* {<}'98 */
{OBJ r;
 if(ISTGPRM(x6,1)){
  FRCLS(x1,1);
  FRCLS(x2,1);
  FREE(x3,1);
  FREE(x4,1);
  FREE(x5,1);
  r=x6;
 }else{
  CPCLS(x1,1);
  CPCLS(x2,2);
  COPY(x5,1);
  {OBJ x7;OBJ x8;OBJ x9;OBJ x10;
   x7=_AMap_17(x1,__ATree_7,x3,x5);
   x8=_AMap_17(x1,__ATree_7,x4,x5);
   x9=_AMap_21(x2,x7);
   x10=_AMap_21(x2,x8);
   r=_ASeq_43(x2,x9,x10);}}
 return r;}

static OBJ _mt_5_0_2(OBJ t,OBJ t1,OBJ t2) 
{OBJ r;
 DPCLS(t,r);
 INCCLS(r,0,2);
 FLDCLS(r,1)=t1;
 FLDCLS(r,2)=t2;
 return r;}

static OBJ _mt_5_2_2(OBJ t,OBJ t1,OBJ t2) 
{OBJ r;
 if(EXCLS(t)){
  r=t;
 }else{
  DPCLS(t,r);
  FLDCLS(r,1)=FLDCLS(t,1);
  FLDCLS(r,2)=FLDCLS(t,2);
  COPY(FLDCLS(r,1),1);
  COPY(FLDCLS(r,2),1);}
 INCCLS(r,2,2);
 FLDCLS(r,3)=t1;
 FLDCLS(r,4)=t2;
 return r;}

static OBJ _mt_5_2_3(OBJ t,OBJ t1,OBJ t2,OBJ t3) 
{OBJ r;
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  COPY(FLDCLS(t,1),1);
  COPY(FLDCLS(t,2),1);
  DCCLS(t,1);}
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),t1,t2,t3);
 return r;}

static OBJ _mt_6_0_2(OBJ t,OBJ t1,OBJ t2) 
{OBJ r;
 DPCLS(t,r);
 INCCLS(r,0,2);
 FLDCLS(r,1)=t1;
 FLDCLS(r,2)=t2;
 return r;}

static OBJ _mt_6_0_3(OBJ t,OBJ t1,OBJ t2,OBJ t3) 
{OBJ r;
 DPCLS(t,r);
 INCCLS(r,0,3);
 FLDCLS(r,1)=t1;
 FLDCLS(r,2)=t2;
 FLDCLS(r,3)=t3;
 return r;}

static OBJ _mt_6_0_4(OBJ t,OBJ t1,OBJ t2,OBJ t3,OBJ t4) 
{OBJ r;
 DPCLS(t,r);
 INCCLS(r,0,4);
 FLDCLS(r,1)=t1;
 FLDCLS(r,2)=t2;
 FLDCLS(r,3)=t3;
 FLDCLS(r,4)=t4;
 return r;}

static OBJ _mt_6_0_5(OBJ t,OBJ t1,OBJ t2,OBJ t3,OBJ t4,OBJ t5) 
{OBJ r;
 DPCLS(t,r);
 INCCLS(r,0,5);
 FLDCLS(r,1)=t1;
 FLDCLS(r,2)=t2;
 FLDCLS(r,3)=t3;
 FLDCLS(r,4)=t4;
 FLDCLS(r,5)=t5;
 return r;}

static OBJ _mt_6_2_2(OBJ t,OBJ t1,OBJ t2) 
{OBJ r;
 if(EXCLS(t)){
  r=t;
 }else{
  DPCLS(t,r);
  FLDCLS(r,1)=FLDCLS(t,1);
  FLDCLS(r,2)=FLDCLS(t,2);
  COPY(FLDCLS(r,1),1);
  COPY(FLDCLS(r,2),1);}
 INCCLS(r,2,2);
 FLDCLS(r,3)=t1;
 FLDCLS(r,4)=t2;
 return r;}

static OBJ _mt_6_2_4(OBJ t,OBJ t1,OBJ t2,OBJ t3,OBJ t4) 
{OBJ r;
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  COPY(FLDCLS(t,1),1);
  COPY(FLDCLS(t,2),1);
  DCCLS(t,1);}
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),t1,t2,t3,t4);
 return r;}

static OBJ _mt_6_3_3(OBJ t,OBJ t1,OBJ t2,OBJ t3) 
{OBJ r;
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  COPY(FLDCLS(t,1),1);
  COPY(FLDCLS(t,2),1);
  COPY(FLDCLS(t,3),1);
  DCCLS(t,1);}
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),FLDCLS(t,3),t1,t2,t3);
 return r;}

static OBJ _mt_6_4_2(OBJ t,OBJ t1,OBJ t2) 
{OBJ r;
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  COPY(FLDCLS(t,1),1);
  COPY(FLDCLS(t,2),1);
  COPY(FLDCLS(t,3),1);
  COPY(FLDCLS(t,4),1);
  DCCLS(t,1);}
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),FLDCLS(t,3),FLDCLS(t,4),t1,t2);
 return r;}

static OBJ _mt_6_5_1(OBJ t,OBJ t1) 
{OBJ r;
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  COPY(FLDCLS(t,1),1);
  COPY(FLDCLS(t,2),1);
  COPY(FLDCLS(t,3),1);
  COPY(FLDCLS(t,4),1);
  COPY(FLDCLS(t,5),1);
  DCCLS(t,1);}
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),FLDCLS(t,3),FLDCLS(t,4),FLDCLS(t,5),t1);
 return r;}
static OBJ _mt_6_5_1_l(OBJ t,OBJ t1) 
{OBJ r;
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),FLDCLS(t,3),FLDCLS(t,4),FLDCLS(t,5),t1);
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  DCCLS(t,1);
  FLDCLS(t,1)=NIL;FLDCLS(t,2)=NIL;FLDCLS(t,3)=NIL;FLDCLS(t,4)=NIL;FLDCLS(t,5)=NIL;
  COPY(r,1);LZYCLS(t,r);}
 return r;}

init_ARel()
{
 static int visited=0; if(visited) return; visited=1;
 init_ASet();
 init_APair();
 init_ATriple();
 init_AOption();
 init_ASeq();
 init_ANat();
 init_AMap();
 init_AMapReduce();
 init_ASetReduce();
 init_AMapFilter();
 init_AMapMap();
 init_AOptionMap();
 init_ASetByBST();
 init_ABSTree();
 init_ATree();
 init_ASeqReduce();
 CLS(4,_ARel_95,__ARel_95);
 CLS(4,_ARel_31,__ARel_31);
 CLS(6,_ARel_63,__ARel_63);
 CLS(4,_ARel_94,__ARel_94);
 CLS(4,_ARel_30,__ARel_30);
 CLS(3,_ARel_62,__ARel_62);
 CLS(5,_ARel_93,__ARel_93);
 CLS(4,_ARel_29,__ARel_29);
 CLS(3,_ARel_61,__ARel_61);
 CLS(2,_ARel_92,__ARel_92);
 CLS(4,_ARel_28,__ARel_28);
 CLS(4,_ARel_60,__ARel_60);
 CLS(4,_ARel_91,__ARel_91);
 CLS(3,_ARel_27_c,__ARel_27);
 CLS(6,_ARel_59,__ARel_59);
 CLS(4,_ARel_90,__ARel_90);
 CLS(3,_ARel_26_c,__ARel_26);
 CLS(3,_ARel_58,__ARel_58);
 CLS(4,_ARel_89,__ARel_89);
 CLS(4,_ARel_25,__ARel_25);
 CLS(3,_ARel_57,__ARel_57);
 CLS(4,_ARel_88,__ARel_88);
 CLS(4,_ARel_24,__ARel_24);
 CLS(3,_ARel_56,__ARel_56);
 CLS(4,_ARel_87,__ARel_87);
 CLS(4,_ARel_23,__ARel_23);
 CLS(4,_ARel_55,__ARel_55);
 CLS(5,_ARel_86,__ARel_86);
 CLS(4,_ARel_22,__ARel_22);
 CLS(4,_ARel_54,__ARel_54);
 CLS(2,_ARel_85,__ARel_85);
 CLS(4,_ARel_21,__ARel_21);
 CLS(4,_ARel_53,__ARel_53);
 CLS(4,_ARel_84,__ARel_84);
 CLS(4,_ARel_20,__ARel_20);
 CLS(4,_ARel_52,__ARel_52);
 CLS(4,_ARel_83,__ARel_83);
 CLS(4,_ARel_19,__ARel_19);
 CLS(4,_ARel_51,__ARel_51);
 CLS(4,_ARel_82,__ARel_82);
 CLS(5,_ARel_18,__ARel_18);
 CLS(4,_ARel_50,__ARel_50);
 CLS(3,_ARel_81,__ARel_81);
 CLS(5,_ARel_17,__ARel_17);
 CLS(4,_ARel_49,__ARel_49);
 CLS(4,_ARel_80,__ARel_80);
 CLS(5,_ARel_16,__ARel_16);
 CLS(4,_ARel_48,__ARel_48);
 CLS(6,_ARel_79,__ARel_79);
 CLS(6,_ARel_15,__ARel_15);
 CLS(4,_ARel_47,__ARel_47);
 CLS(6,_ARel_78,__ARel_78);
 CLS(6,_ARel_14,__ARel_14);
 CLS(4,_ARel_46,__ARel_46);
 CLS(5,_ARel_77,__ARel_77);
 CLS(5,_ARel_13,__ARel_13);
 CLS(4,_ARel_45,__ARel_45);
 CLS(3,_ARel_76,__ARel_76);
 CLS(3,_ARel_44_c,__ARel_44);
 CLS(4,_ARel_75,__ARel_75);
 CLS(5,_ARel_11,__ARel_11);
 CLS(3,_ARel_43_c,__ARel_43);
 CLS(3,_ARel_74,__ARel_74);
 CLS(5,_ARel_10,__ARel_10);
 CLS(3,_ARel_42,__ARel_42);
 CLS(3,_ARel_73,__ARel_73);
 CLS(6,_ARel_9,__ARel_9);
 CLS(3,_ARel_41,__ARel_41);
 CLS(4,_ARel_72,__ARel_72);
 CLS(6,_ARel_8,__ARel_8);
 CLS(3,_ARel_40,__ARel_40);
 CLS(2,_ARel_71,__ARel_71);
 CLS(2,_ARel_7,__ARel_7);
 CLS(3,_ARel_39,__ARel_39);
 CLS(4,_ARel_70,__ARel_70);
 CLS(3,_ARel_38,__ARel_38);
 CLS(6,_ARel_69,__ARel_69);
 CLS(4,_ARel_37,__ARel_37);
 CLS(6,_ARel_68,__ARel_68);
 CLS(4,_ARel_36,__ARel_36);
 CLS(5,_ARel_67,__ARel_67);
 CLS(5,_ARel_35,__ARel_35);
 CLS(6,_ARel_98,__ARel_98);
 CLS(3,_ARel_34,__ARel_34);
 CLS(5,_ARel_66,__ARel_66);
 CLS(5,_ARel_97,__ARel_97);
 CLS(5,_ARel_33,__ARel_33);
 CLS(6,_ARel_65,__ARel_65);
 CLS(6,_ARel_96,__ARel_96);
 CLS(5,_ARel_32,__ARel_32);
 CLS(3,_ARel_64,__ARel_64);
 MTH(5,0,2,_mt_5_0_2);LZYMTH(5,0,2,_mt_5_0_2);
 MTH(5,2,2,_mt_5_2_2);LZYMTH(5,2,2,_mt_5_2_2);
 MTH(5,2,3,_mt_5_2_3);LZYMTH(5,2,3,_mt_5_2_3);
 MTH(6,0,2,_mt_6_0_2);LZYMTH(6,0,2,_mt_6_0_2);
 MTH(6,0,3,_mt_6_0_3);LZYMTH(6,0,3,_mt_6_0_3);
 MTH(6,0,4,_mt_6_0_4);LZYMTH(6,0,4,_mt_6_0_4);
 MTH(6,0,5,_mt_6_0_5);LZYMTH(6,0,5,_mt_6_0_5);
 MTH(6,2,2,_mt_6_2_2);LZYMTH(6,2,2,_mt_6_2_2);
 MTH(6,2,4,_mt_6_2_4);LZYMTH(6,2,4,_mt_6_2_4);
 MTH(6,3,3,_mt_6_3_3);LZYMTH(6,3,3,_mt_6_3_3);
 MTH(6,4,2,_mt_6_4_2);LZYMTH(6,4,2,_mt_6_4_2);
 MTH(6,5,1,_mt_6_5_1);LZYMTH(6,5,1,_mt_6_5_1_l);}

